Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 15032)
@@ -9,7 +9,10 @@
 
   /// <summary>
-  ///     Pushes the sum of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.+")]
+  /// Pushes the sum of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.+",
+    "Pushes the sum of the top two items.")]
   [StorableClass]
   public class IntegerAddExpression : StatelessExpression {
@@ -32,7 +35,10 @@
 
   /// <summary>
-  ///     Pushes the difference of the top two items; that is, the second item minus the top item.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.-")]
+  /// Pushes the difference of the top two items; that is, the second item minus the top item.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.-",
+    "Pushes the difference of the top two items; that is, the second item minus the top item.")]
   [StorableClass]
   public class IntegerSubtractExpression : StatelessExpression {
@@ -55,7 +61,10 @@
 
   /// <summary>
-  ///     Pushes the product of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.*")]
+  /// Pushes the product of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.*",
+    "Pushes the product of the top two items.")]
   [StorableClass]
   public class IntegerMultiplyExpression : StatelessExpression {
@@ -78,8 +87,11 @@
 
   /// <summary>
-  ///     Pushes the quotient of the top two items; that is, the second item divided by the top item.
-  ///     If the top item is zero this acts as a NOOP.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER./")]
+  /// Pushes the quotient of the top two items; that is, the second item divided by the top item.
+  /// If the top item is zero this acts as a NOOP.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER./",
+    "Pushes the quotient of the top two items; that is, the second item divided by the top item. If the top item is zero this acts as a NOOP.")]
   [StorableClass]
   public class IntegerDivideExpression : StatelessExpression {
@@ -102,10 +114,10 @@
 
   /// <summary>
-  ///     Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP. The modulus is
-  ///     computed as the remainder of the quotient, where the quotient has first been truncated toward negative infinity. (This is taken
-  ///     from the definition for the generic MOD function in Common Lisp, which is described for example at
-  ///     http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.%")]
+  /// Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.%",
+    "Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.")]
   [StorableClass]
   public class IntegerModuloExpression : StatelessExpression {
@@ -128,7 +140,10 @@
 
   /// <summary>
-  ///     Pushes the minimum of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.MIN")]
+  /// Pushes the minimum of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.MIN",
+    "Pushes the minimum of the top two items.")]
   [StorableClass]
   public class IntegerMinExpression : StatelessExpression {
@@ -151,7 +166,10 @@
 
   /// <summary>
-  ///     Pushes the maximum of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.MAX")]
+  /// Pushes the maximum of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.MAX",
+    "Pushes the maximum of the top two items.")]
   [StorableClass]
   public class IntegerMaxExpression : StatelessExpression {
@@ -174,7 +192,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.<", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.<",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class IntegerSmallerThanExpression : StatelessExpression {
@@ -198,7 +220,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than or equal to the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.<=", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is less than or equal to the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.<=",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is less than or equal to the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class IntegerSmallerOrEqualToExpression : StatelessExpression {
@@ -222,7 +248,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.>", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.>",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class IntegerGreaterThanExpression : StatelessExpression {
@@ -247,7 +277,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.>=", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.>=",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class IntegerGreaterOrEqualToExpression : StatelessExpression {
@@ -271,7 +305,11 @@
 
   /// <summary>
-  ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.FROMBOOLEAN", StackTypes.Boolean)]
+  /// Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.FROMBOOLEAN",
+    "Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class IntegerFromBooleanExpression : StatelessExpression {
@@ -292,7 +330,11 @@
 
   /// <summary>
-  ///     Pushes the result of truncating the top FLOAT.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.FROMFLOAT", StackTypes.Float)]
+  /// Pushes the result of truncating the top FLOAT.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.FROMFLOAT",
+    "Pushes the result of truncating the top FLOAT.",
+    StackTypes.Float)]
   [StorableClass]
   public class IntegerFromFloatExpression : StatelessExpression {
@@ -312,7 +354,11 @@
 
   /// <summary>
-  ///     Pushes the result of truncating the top CHAR.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.FROMCHAR", StackTypes.Char)]
+  /// Pushes the result of truncating the top CHAR.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.FROMCHAR",
+    "Pushes the result of truncating the top CHAR.",
+    StackTypes.Char)]
   [StorableClass]
   public class IntegerFromCharExpression : StatelessExpression {
@@ -332,7 +378,11 @@
 
   /// <summary>
-  ///     Pushes the result of parsing the top STRING.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.FROMSTRING", StackTypes.String)]
+  /// Pushes the result of parsing the top STRING.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.FROMSTRING",
+    "Pushes the result of parsing the top STRING.",
+    StackTypes.String)]
   [StorableClass]
   public class IntegerFromStringExpression : StatelessExpression {
@@ -357,7 +407,10 @@
 
   /// <summary>
-  ///     Pushes the result of increasing the top INTEGER by 1.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.INC")]
+  /// Pushes the result of increasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.INC",
+    "Pushes the result of increasing the top INTEGER by 1.")]
   [StorableClass]
   public class IntegerIncExpression : StatelessExpression {
@@ -376,7 +429,10 @@
 
   /// <summary>
-  ///     Pushes the result of decreasing the top INTEGER by 1.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.DEC")]
+  /// Pushes the result of decreasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.DEC",
+    "Pushes the result of decreasing the top INTEGER by 1.")]
   [StorableClass]
   public class IntegerDecExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 15032)
@@ -30,11 +30,12 @@
 
   /// <summary>
-  ///     Sets a flag indicating that the next State encountered will be pushed onto the NAME stack (and not have its
-  ///     associated value
-  ///     pushed onto the EXEC stack), regardless of whether or not it has a definition. Upon encountering such a State and
-  ///     pushing it
-  ///     onto the NAME stack the flag will be cleared (whether or not the pushed State had a definition).
+  /// Sets a flag indicating that the next State encountered will be pushed onto the NAME stack (and not have its
+  /// associated value pushed onto the EXEC stack), regardless of whether or not it has a definition. Upon encountering such a State and
+  /// pushing it onto the NAME stack the flag will be cleared (whether or not the pushed State had a definition).
   /// </summary>
-  [PushExpression(StackTypes.Name, "NAME.QUOTE")]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.QUOTE",
+    "Sets a flag indicating that the next State encountered will be pushed onto the NAME stack")]
   [StorableClass]
   public class NameQuoteExpression : StatelessExpression {
@@ -53,7 +54,10 @@
 
   /// <summary>
-  ///     Pushes a randomly selected NAME that already has a definition.
+  /// Pushes a randomly selected NAME that already has a definition.
   /// </summary>
-  [PushExpression(StackTypes.Name, "NAME.RANDBOUNDNAME")]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.RANDBOUNDNAME",
+    "Pushes a randomly selected NAME that already has a definition.")]
   [StorableClass]
   public class NameRandBoundNameExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15032)
@@ -20,5 +20,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.POP")]
+  [PushExpression(StackTypes.Integer, "INTEGER.POP", "Pops the top INTEGER item.")]
   public class IntegerPopExpression : PopExpression<long> {
     public IntegerPopExpression() { }
@@ -36,5 +36,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Float, "FLOAT.POP")]
+  [PushExpression(StackTypes.Float, "FLOAT.POP", "Pops the top FLOAT item.")]
   public class FloatPopExpression : PopExpression<double> {
     public FloatPopExpression() { }
@@ -52,5 +52,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.POP")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.POP", "Pops the top BOOLEAN item.")]
   public class BooleanPopExpression : PopExpression<bool> {
     public BooleanPopExpression() { }
@@ -68,5 +68,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Name, "NAME.POP")]
+  [PushExpression(StackTypes.Name, "NAME.POP", "Pops the top NAME item.")]
   public class NamePopExpression : PopExpression<string> {
     public NamePopExpression() { }
@@ -84,5 +84,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.POP", execIn: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.POP", "Pops the top EXEC item.", execIn: 1)]
   public class ExecPopExpression : PopExpression<Expression> {
     public ExecPopExpression() { }
@@ -100,5 +100,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.POP")]
+  [PushExpression(StackTypes.Code, "CODE.POP", "Pops the top CODE item.")]
   public class CodePopExpression : PopExpression<Expression> {
     public CodePopExpression() { }
@@ -116,5 +116,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Char, "CHAR.POP")]
+  [PushExpression(StackTypes.Char, "CHAR.POP", "Pops the top CHAR item.")]
   public class CharPopExpression : PopExpression<char> {
     public CharPopExpression() { }
@@ -132,5 +132,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.POP")]
+  [PushExpression(StackTypes.String, "STRING.POP", "Pops the top STRING item.")]
   public class StringPopExpression : PopExpression<string> {
     public StringPopExpression() { }
@@ -148,5 +148,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].POP")]
+  [PushExpression(StackTypes.IntegerVector, "INTEGER[].POP", "Pops the top INTEGER[] item.")]
   public class IntegerVectorPopExpression : PopExpression<IReadOnlyList<long>> {
     public IntegerVectorPopExpression() { }
@@ -164,5 +164,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].POP")]
+  [PushExpression(StackTypes.FloatVector, "FLOAT[].POP", "Pops the top FLOAT[] item.")]
   public class FloatVectorPopExpression : PopExpression<IReadOnlyList<double>> {
     public FloatVectorPopExpression() { }
@@ -180,5 +180,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].POP")]
+  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].POP", "Pops the top BOOLEAN[] item.")]
   public class BooleanVectorPopExpression : PopExpression<IReadOnlyList<bool>> {
     public BooleanVectorPopExpression() { }
@@ -196,5 +196,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].POP")]
+  [PushExpression(StackTypes.StringVector, "STRING[].POP", "Pops the top STRING[] item.")]
   public class StringVectorPopExpression : PopExpression<IReadOnlyList<string>> {
     public StringVectorPopExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15032)
@@ -10,5 +10,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.NEWLINE")]
+  [PushExpression(StackTypes.Print, "PRINT.NEWLINE", "Pushes an empty string onto the PRINT STACK.")]
   public class PrintNewLineExpression : StatelessExpression {
     public PrintNewLineExpression() { }
@@ -63,5 +63,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTBOOLEAN", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTBOOLEAN",
+    "Pushes the top BOOLEAN onto the PRINT stack.",
+    StackTypes.Boolean)]
   public class BooleanPrintExpression : PrintExpression<bool> {
     public BooleanPrintExpression() { }
@@ -79,5 +83,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTCHAR", StackTypes.Char)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTCHAR",
+    "Pushes the top CHAR onto the PRINT stack.",
+    StackTypes.Char)]
   public class CharPrintExpression : PrintExpression<char> {
     public CharPrintExpression() { }
@@ -95,5 +103,10 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTEXEC", StackTypes.Exec, execIn: 1)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTEXEC",
+    "Pushes the top BOOLEAN onto the EXEC stack.",
+    StackTypes.Exec,
+    execIn: 1)]
   public class ExecPrintExpression : PrintExpression<Expression> {
     public ExecPrintExpression() { }
@@ -111,5 +124,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTFLOAT", StackTypes.Float)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTFLOAT",
+    "Pushes the top FLOAT onto the PRINT stack.",
+    StackTypes.Float)]
   public class FloatPrintExpression : PrintExpression<double> {
     public FloatPrintExpression() { }
@@ -133,5 +150,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTINTEGER", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTINTEGER",
+    "Pushes the top INTEGER onto the PRINT stack.",
+    StackTypes.Integer)]
   public class IntegerPrintExpression : PrintExpression<long> {
     public IntegerPrintExpression() { }
@@ -149,5 +170,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTSTRING", StackTypes.String)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTSTRING",
+    "Pushes the top STRING onto the PRINT stack.",
+    StackTypes.String)]
   public class StringPrintExpression : PrintExpression<string> {
     public StringPrintExpression() { }
@@ -165,5 +190,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTINTEGERVECTOR", StackTypes.IntegerVector)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTINTEGERVECTOR",
+    "Pushes the top INTEGER[] onto the PRINT stack.",
+    StackTypes.IntegerVector)]
   public class IntegerVectorPrintExpression : PrintExpression<long> {
     public IntegerVectorPrintExpression() { }
@@ -181,5 +210,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTFLOATVECTOR", StackTypes.FloatVector)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTFLOATVECTOR",
+    "Pushes the top FLOAT[] onto the PRINT stack.",
+    StackTypes.FloatVector)]
   public class FloatVectorPrintExpression : PrintExpression<double> {
     public FloatVectorPrintExpression() { }
@@ -197,5 +230,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTSTRINGVECTOR", StackTypes.StringVector)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTSTRINGVECTOR",
+    "Pushes the top STRING[] onto the PRINT stack.",
+    StackTypes.StringVector)]
   public class StringVectorPrintExpression : PrintExpression<string> {
     public StringVectorPrintExpression() { }
@@ -213,5 +250,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Print, "PRINT.PRINTBOOLEANVECTOR", StackTypes.BooleanVector)]
+  [PushExpression(
+    StackTypes.Print,
+    "PRINT.PRINTBOOLEANVECTOR",
+    "Pushes the top BOOLEAN[] onto the PRINT stack.",
+    StackTypes.BooleanVector)]
   public class BooleanVectorPrintExpression : PrintExpression<bool> {
     public BooleanVectorPrintExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 15032)
@@ -49,5 +49,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Integer, "INTEGER.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.Integer, "INTEGER.PUSH", "Pushes a specific integer onto the INTEGER stack", isHidden: true)]
   public class IntegerPushExpression : PushExpression<long> {
     [StorableConstructor]
@@ -78,5 +78,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Float, "FLOAT.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.Float, "FLOAT.PUSH", "Pushes a specific float onto the FLOAT stack", isHidden: true)]
   public class FloatPushExpression : PushExpression<double> {
     [StorableConstructor]
@@ -107,5 +107,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.PUSH", "Pushes a specific boolean onto the BOOLEAN stack", isHidden: true)]
   public class BooleanPushExpression : PushExpression<bool> {
     [StorableConstructor]
@@ -136,5 +136,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Name, "NAME.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.Name, "NAME.PUSH", "Pushes a specific name onto the NAME stack", isHidden: true)]
   public class NamePushExpression : PushExpression<string> {
     [StorableConstructor]
@@ -161,5 +161,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Exec, "EXEC.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.Exec, "EXEC.PUSH", "Pushes a specific expression onto the EXEC stack", isHidden: true)]
   public class ExecPushExpression : PushExpression<Expression> {
     [StorableConstructor]
@@ -191,5 +191,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Char, "CHAR.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.Char, "CHAR.PUSH", "Pushes a specific char onto the CHAR stack", isHidden: true)]
   public class CharPushExpression : PushExpression<char> {
     [StorableConstructor]
@@ -225,5 +225,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.String, "STRING.PUSH", isHidden: true)]
+  [PushExpression(StackTypes.String, "STRING.PUSH", "Pushes a specific string onto the STRING stack", isHidden: true)]
   public class StringPushExpression : PushExpression<string> {
     [StorableConstructor]
@@ -258,5 +258,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].PUSH", isHidden: true)]
+  [PushExpression(StackTypes.IntegerVector, "INTEGER[].PUSH", "Pushes a specific integer vector onto the INTEGER[] stack", isHidden: true)]
   public class IntegerVectorPushExpression : VectorPushExpression<long> {
     [StorableConstructor]
@@ -289,5 +289,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].PUSH", isHidden: true)]
+  [PushExpression(StackTypes.FloatVector, "FLOAT[].PUSH", "Pushes a specific float vector onto the FLOAT[] stack", isHidden: true)]
   public class FloatVectorPushExpression : VectorPushExpression<double> {
     [StorableConstructor]
@@ -319,5 +319,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].PUSH", isHidden: true)]
+  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].PUSH", "Pushes a specific boolean vector onto the BOOLEAN[] stack", isHidden: true)]
   public class BooleanVectorPushExpression : VectorPushExpression<bool> {
     [StorableConstructor]
@@ -349,5 +349,5 @@
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.StringVector, "STRING[].PUSH", isHidden: true)]
+  [PushExpression(StackTypes.StringVector, "STRING[].PUSH", "Pushes a specific string vector onto the STRING[] stack", isHidden: true)]
   public class StringVectorPushExpression : VectorPushExpression<string> {
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 15032)
@@ -11,7 +11,10 @@
 
   /// <summary>
-  ///     Pushes a random NAME.
-  /// </summary>
-  [PushExpression(StackTypes.Name, "NAME.RAND")]
+  /// Pushes a random already defined name or a new one onto the NAME stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.RAND",
+    "Pushes a random already defined name or a new one based on the Name-ERC-Options onto the NAME stack.")]
   [StorableClass]
   public class NameRandExpression : StatelessExpression {
@@ -31,7 +34,10 @@
 
   /// <summary>
-  ///     Pushes a random integer.
-  /// </summary>
-  [PushExpression(StackTypes.Integer, "INTEGER.RAND")]
+  /// Pushes a random integer.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.RAND",
+    "Pushes a random integer based on the Integer-ERC-Options  onto the INTEGER stack.")]
   [StorableClass]
   public class IntegerRandExpression : StatelessExpression {
@@ -51,7 +57,10 @@
 
   /// <summary>
-  ///     Pushes a random float.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.RAND")]
+  ///  Pushes a random float.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.RAND",
+    "Pushes a random float based on the Float-ERC-Options onto the FLOAT stack.")]
   [StorableClass]
   public class FloatRandExpression : StatelessExpression {
@@ -73,5 +82,8 @@
   ///     Pushes a random boolean.
   /// </summary>
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.RAND")]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.RAND",
+    "Pushes a random boolean based on the Boolean-ERC-Options onto the BOOLEAN stack.")]
   [StorableClass]
   public class BooleanRandExpression : StatelessExpression {
@@ -93,5 +105,8 @@
   ///     Pushes random expressions onto the code stack.
   /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.RAND")]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.RAND",
+    "Pushes a random code onto the CODE stack.")]
   [StorableClass]
   public class CodeRandExpression : StatelessExpression {
@@ -121,5 +136,8 @@
   ///     Pushes a random char.
   /// </summary>
-  [PushExpression(StackTypes.Char, "CHAR.RAND")]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.RAND",
+    "Pushes a random char based on the Char-ERC-Options onto the CHAR stack.")]
   [StorableClass]
   public class CharRandExpression : StatelessExpression {
@@ -140,5 +158,8 @@
     ///     Pushes a random string.
     /// </summary>
-    [PushExpression(StackTypes.String, "STRING.RAND")]
+    [PushExpression(
+      StackTypes.String,
+      "STRING.RAND",
+      "Pushes a random string based on the String-ERC-Options onto the STRING stack.")]
     [StorableClass]
     public class StringRandExpression : StatelessExpression {
@@ -159,5 +180,8 @@
       ///     Pushes a random interger vector.
       /// </summary>
-      [PushExpression(StackTypes.IntegerVector, "INTEGER[].RAND")]
+      [PushExpression(
+        StackTypes.IntegerVector,
+        "INTEGER[].RAND",
+        "Pushes a random integer vector based on the Integer-Vector-ERC-Options onto the INTEGER[] stack.")]
       [StorableClass]
       public class IntegerVectorRandExpression : StatelessExpression {
@@ -179,5 +203,8 @@
       ///     Pushes a random float vector.
       /// </summary>
-      [PushExpression(StackTypes.FloatVector, "FLOAT[].RAND")]
+      [PushExpression(
+        StackTypes.FloatVector,
+        "FLOAT[].RAND",
+        "Pushes a random float vector based on the Float-Vector-ERC-Options onto the FLOAT[] stack.")]
       [StorableClass]
       public class FloatVectorRandExpression : StatelessExpression {
@@ -199,5 +226,8 @@
       ///     Pushes a random boolean vector.
       /// </summary>
-      [PushExpression(StackTypes.StringVector, "STRING[].RAND")]
+      [PushExpression(
+        StackTypes.StringVector,
+        "STRING[].RAND",
+        "Pushes a random string vector based on the String-Vector-ERC-Options onto the STRING[] stack.")]
       [StorableClass]
       public class StringVectorRandExpression : StatelessExpression {
